## index.php?dir=linux%2Fredhat%2Fpub%2Fredhat%2Frhceph-ubuntu%2F2%2F&file=nfs-ganesha_2.3.2.orig.tar.gz

=== src/CMakeLists.txt ===
# NFS Ganesha  Cmake

# Current version as of Fedora 16.  Not tested with earlier.

cmake_minimum_required(VERSION 2.6.3)

message( STATUS "cmake version ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" )

if( "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" VERSION_GREATER "2.6" )
  if(COMMAND cmake_policy)
      cmake_policy(SET CMP0017 NEW)
  endif(COMMAND cmake_policy)
endif( "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" VERSION_GREATER "2.6" )

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules/")

project(nfs-ganesha C)
# Project versioning
set(GANESHA_MAJOR_VERSION 2)
set(GANESHA_MINOR_VERSION 3)

# needs to come after project()
IF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT OR CMAKE_INSTALL_PREFIX STREQUAL "/usr")
	SET(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "Install prefix for common files" FORCE)
	message(STATUS "override default CMAKE_INSTALL_PREFIX = ${CMAKE_INSTALL_PREFIX}")
	SET(SYSCONFDIR "/etc" CACHE PATH "Install prefix for common files" FORCE)
	SET(SYSSTATEDIR "/var" CACHE PATH "Install prefix for common files" FORCE)
ELSE()
	message(STATUS "was set CMAKE_INSTALL_PREFIX = ${CMAKE_INSTALL_PREFIX}")
	SET(SYSCONFDIR "${CMAKE_INSTALL_PREFIX}/etc" CACHE PATH "Install prefix for common files" FORCE)
	SET(SYSSTATEDIR "${CMAKE_INSTALL_PREFIX}/var" CACHE PATH "Install prefix for common files" FORCE)
ENDIF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT OR CMAKE_INSTALL_PREFIX STREQUAL "/usr")
# Patch level is always ".0" for mainline (master).  It is blank for development.
# When starting a stable maintenance branch, this becomes ".N"
# where N is monotonically increasing starting at 1. Remember to include the "." !!
set(GANESHA_PATCH_LEVEL .2)

# Extra version is for naming development/RC.  It is blank in master/stable branches
# so it can be available to end-users to name local variants/versions
# If used, it is always of the form "-whateveryouwant"
set(GANESHA_EXTRA_VERSION)

set(GANESHA_VERSION ${GANESHA_MAJOR_VERSION}.${GANESHA_MINOR_VERSION}${GANESHA_PATCH_LEVEL}${GANESHA_EXTRA_VERSION})
set(GANESHA_BASE_VERSION ${GANESHA_MAJOR_VERSION}.${GANESHA_MINOR_VERSION}${GANESHA_PATCH_LEVEL})

set(VERSION_COMMENT
  "GANESHA file server is 64 bits compliant and supports NFS v3,4.0,4.1 (pNFS) and 9P"
)

# find out which platform we are building on
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  set(LINUX ON)
  set(UNIX ON)
  # Now detects the Linux's distro
  set(DISTRO "UNKNOWN")
  set(LIBEXECDIR "/usr/libexec")

  EXECUTE_PROCESS(
      COMMAND awk -F=  "/^NAME=/ { print $2 }" /etc/os-release
      OUTPUT_VARIABLE SYS_RELEASE
      ERROR_QUIET
   )
# Red Hat Enterprise Linux versions before 7.0 will be detected as UNKNOWN

  if( ${SYS_RELEASE} MATCHES "Red Hat" )
     message( STATUS "Detected a Linux Red Hat machine" )
     set(DISTRO "RED_HAT")
  elseif( ${SYS_RELEASE} MATCHES "Fedora" )
     message( STATUS "Detected a Linux Fedora machine" )
     set(DISTRO "FEDORA")
  elseif( ${SYS_RELEASE} MATCHES "SLES" )
     message( STATUS "Detected a Linux SLES machine" )
     set(DISTRO "SLES")
     set(LIBEXECDIR "/usr/lib")
  else( ${SYS_RELEASE} MATCHES "Red Hat" )
     message( STATUS "Detected an UNKNOWN Linux machine" )
     set(DISTRO "UNKNOWN")
  endif( ${SYS_RELEASE} MATCHES "Red Hat" )
endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
  set(FREEBSD ON)
  set(UNIX ON)
# On FreeBSD libc doesn't directly provide libexecinfo, so we have to find it
  set(USE_EXECINFO ON)
endif(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  set(WINDOWS ON)
endif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

# Identify the host we are building on
EXECUTE_PROCESS( COMMAND hostname
  OUTPUT_VARIABLE BUILD_HOST_NAME
  OUTPUT_STRIP_TRAILING_WHITESPACE
  )

find_package(Toolchain REQUIRED)

# Add maintainer mode for (mainly) strict builds
include(${CMAKE_SOURCE_DIR}/cmake/maintainer_mode.cmake)

# For libraries that provide pkg-config files
include(FindPkgConfig)

# If we are in a git tree, then this CMakeLists.txt is in "src/" and go .git is in "src/.."
IF( EXISTS ${CMAKE_SOURCE_DIR}/../.git/HEAD  )
  message( STATUS "Compilation from within a git repository. Using git rev-parse HEAD")
  EXECUTE_PROCESS( COMMAND git rev-parse HEAD
		   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		   OUTPUT_STRIP_TRAILING_WHITESPACE
		   ERROR_QUIET
                   OUTPUT_VARIABLE _GIT_HEAD_COMMIT)
  EXECUTE_PROCESS( COMMAND git describe --long
                   WORKING_DIRECTORY  ${CMAKE_SOURCE_DIR}
		   OUTPUT_STRIP_TRAILING_WHITESPACE
		   ERROR_QUIET
                   OUTPUT_VARIABLE _GIT_DESCRIBE)

ELSE( EXISTS ${CMAKE_SOURCE_DIR}/../.git/HEAD  )
  message( STATUS "Outside a git repository, use saved data" )
  EXEC_PROGRAM(${CMAKE_SOURCE_DIR}/cmake/githead_from_path.sh ARGS ${CMAKE_SOURCE_DIR}
                OUTPUT_VARIABLE  _GIT_HEAD_COMMIT)

  EXEC_PROGRAM(${CMAKE_SOURCE_DIR}/cmake/gitdesc_from_path.sh ARGS ${CMAKE_SOURCE_DIR}
                OUTPUT_VARIABLE  _GIT_DESCRIBE)

ENDIF( EXISTS ${CMAKE_SOURCE_DIR}/../.git/HEAD  )

STRING(SUBSTRING ${_GIT_HEAD_COMMIT} 0  7 _GIT_HEAD_COMMIT_ABBREV )

# Using git related information, build PACKNAME
set( PACKNAME "${GANESHA_VERSION}" )

# Define CPACK component (to deal with sub packages)
set(CPACK_COMPONENTS_ALL daemon fsal headers )
set(CPACK_COMPONENT_DAEMON_DISPLAY_NAME "NFS-Ganesha daemon")

# Include custom config and cpack module
include(${CMAKE_SOURCE_DIR}/cmake/cpack_config.cmake)
include(CPack)

if (FREEBSD)
#default gcc doesn't like using -Wuninitialized without -O on FreeBSD
    set(PLATFORM "FREEBSD")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O2 -ggdb")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-omit-frame-pointer")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-optimize-sibling-calls")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--export-dynamic")
    set(OS_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/include/os/freebsd")
    find_library(LIBDL c)  # libc suffices on freebsd
endif(FREEBSD)

if (LINUX)
    set(PLATFORM "LINUX")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_LARGEFILE64_SOURCE")
    set(OS_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/include/os/linux")
    find_library(LIBDL dl)  # module loader
endif(LINUX)

if (MSVC)
   add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif(MSVC)

# Library path name
get_property(USE_LIB64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
if (USE_LIB64)
	set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib64 CACHE PATH
		"Specify name of libdir inside install path")
else (USE_LIB64)
	set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib CACHE PATH
		"Specify name of libdir inside install path")
endif (USE_LIB64)

IF(FSAL_DESTINATION)
    set( FSAL_DESTINATION ${FSAL_DESTINATION} )
ELSE()
    set( FSAL_DESTINATION "${LIB_INSTALL_DIR}/ganesha")
ENDIF()

# FSAL selection
# FSALs which are enabled by default but could be disabled
# during the build
option(USE_FSAL_PROXY "build PROXY FSAL shared library" ON)
option(USE_FSAL_VFS "build VFS FSAL shared library" ON)
option(USE_FSAL_CEPH "build CEPH FSAL shared library" ON)
option(USE_FSAL_GPFS "build GPFS FSAL" ON)
option(USE_FSAL_ZFS "build ZFS FSAL" ON)
option(USE_FSAL_LUSTRE "build LUSTRE FSAL" ON)
option(USE_FSAL_XFS "build XFS support in VFS FSAL" ON)
option(USE_FSAL_PANFS "build PanFS support in VFS FSAL" ON)
option(USE_FSAL_GLUSTER "build GLUSTER FSAL shared library" ON)
option(USE_FSAL_NULL "build NULL FSAL shared library" ON)
option(USE_FSAL_RGW "build RGW FSAL shared library" OFF)

# FSALs which are disabled by default
option(USE_FSAL_PT "build PT FSAL" OFF)
option(USE_FSAL_HPSS "build HPSS FSAL" OFF)

# SHOOK is a variant of Lustre FSAL
option(USE_FSAL_SHOOK "build SHOOK FSAL" ON)

# Activate FSAL Upcalls for FSAL_LUSTRE
option(USE_FSAL_LUSTRE_UP "add Upcalls support for LUSTRE FSAL" OFF)

# nTIRPC
option(USE_SYSTEM_NTIRPC "Use the system nTIRPC, rather than the submodule" OFF)
option (USE_GSS "enable RPCSEC_GSS support" ON)
option(TIRPC_EPOLL "platform supports EPOLL or emulation" ON)

# Build configure options
option(USE_DBUS "enable DBUS protocol support" OFF)

# Various DBUS enabled features
option(USE_CB_SIMULATOR "enable callback simulator thread" OFF)

option(USE_NFSIDMAP "Use of libnfsidmap for name resolution" ON)
option(ENABLE_ERROR_INJECTION "enable error injection" OFF)
option(ENABLE_VFS_DEBUG_ACL "Enable debug ACL store for VFS" OFF)
option(ENABLE_RFC_ACL "Use all RFC ACL checks" OFF)

# Electric Fence (-lefence) link flag
option(USE_EFENCE "link with efence memory debug library" OFF)

# These are -D_FOO options, why ???  should be flags??
option(_NO_TCP_REGISTER "disable registration of tcp services on portmapper" ON)
option(_NO_PORTMAPPER "disable registration on portmapper" ON)
option(_NO_XATTRD "disable ghost xattr directory and files support" ON)
option(DEBUG_SAL "enable debugging of SAL by keeping list of all locks, stateids, and state owners" OFF)
option(_VALGRIND_MEMCHECK "Initialize buffers passed to GPFS ioctl that valgrind doesn't understand" OFF)
option(ENABLE_LOCKTRACE "Enable lock trace" OFF)
option(PROXY_HANDLE_MAPPING "enable NFSv3 handle mapping for PROXY FSAL" OFF)

# Debug symbols (-g) build flag
option(DEBUG_SYMS "include debug symbols to binaries (-g option)" OFF)

# Add coverage information to build tree
option(COVERAGE "add flag to generate coverage data at runtime" OFF)

# Add coverage information to build tree
option(ENFORCE_GCC "enforce gcc as a the C compiler used for the project" OFF)

# enable code profiling [-g -pg]
option(PROFILING "turn on code profiling (-g and -pg)" OFF)

# MSPAC support -lwbclient link flag
if( "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" VERSION_GREATER "2.6" )
  option(_MSPAC_SUPPORT "enable mspac Winbind support" ON)
else( "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" VERSION_GREATER "2.6" )
  option(_MSPAC_SUPPORT "enable mspac Winbind support" OFF)
endif( "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" VERSION_GREATER "2.6" )

# CUnit
option(USE_CUNIT "Use Cunit test framework" OFF)

# Blkin (Zipkin) Tracing
option(USE_BLKIN "Use Blkin/Zipkin trace framework" OFF)
option(BLKIN_PREFIX "Blkin installation prefix" "/opt/blkin")
if(USE_BLKIN)
  find_package(LTTng)
  if(LTTNG_FOUND)
  else(LTTNG_FOUND)
    message(WARNING "LTTng libraries not found. Disabling USE_BLKIN")
    set(USE_BLKIN OFF)
  endif(LTTNG_FOUND)
  if (NOT BLKIN_PREFIX)
    set(BLKIN_PREFIX "/opt/blkin")
  endif(NOT BLKIN_PREFIX)
  set(BLKIN_PREFIX ${BLKIN_PREFIX} CACHE PATH "Blkin path")
  find_library(BLKIN NAMES blkin PATHS "${BLKIN_PREFIX}/lib" REQUIRED)
  find_library(BLKIN_INIT NAMES blkin_init PATHS "${BLKIN_REFIX}/lib" REQUIRED)
  find_library(LTTNG NAMES lttng-ust REQUIRED)
  # build flags
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DHAVE_BLKIN -I${BLKIN_PREFIX}/include")
  set(SYSTEM_LIBRARIES ${BLKIN} ${SYSTEM_LIBRARIES})
  set(SYSTEM_LIBRARIES ${LTTNG}  ${SYSTEM_LIBRARIES})
endif(USE_BLKIN)

# NFS RDMA
option(USE_NFS_RDMA "enable NFS/RDMA support" OFF)

# Enable 9P Support
option(USE_9P "enable 9P support" ON)
option(USE_9P_RDMA "enable 9P_RDMA support" OFF)

# This option will stop cmake compilation if a requested FSAL could not be built
option(STRICT_PACKAGE "Enable strict packaging behavior" OFF )

# This option will trigger "long distro name" aka name that contains git information
option(DISTNAME_HAS_GIT_DATA "Distribution package's name carries git data" OFF )

# Build and package Python admin scripts for managing via DBus
option(USE_ADMIN_TOOLS "Package Admin scripts" OFF)

# Build and package Python gui admin scripts for managing via DBus
option(USE_GUI_ADMIN_TOOLS "Package GUI Admin scripts" ON)

# Enable GCC Thread-sanitizer
option(USE_TSAN "Enable GCC Thread-Sanitizer" OFF)

# Enable LTTng tracing
option(USE_LTTNG "Enable LTTng tracing" OFF)

#
# End build options
#

# Choose a shortcut build config

IF(BUILD_CONFIG)
  INCLUDE(
  ${CMAKE_SOURCE_DIR}/cmake/build_configurations/${BUILD_CONFIG}.cmake)
ENDIF()

IF(DEBUG_SYMS)

=== src/FSAL/CMakeLists.txt ===
# Add the directory for stackable FSALs
add_subdirectory(Stackable_FSALs)

# Add the directory for Pseudo FSAL
add_subdirectory(FSAL_PSEUDO)

# All we need to do here is control the
# build of chosen fsals

if(USE_FSAL_HPSS)
  add_subdirectory(FSAL_HPSS)
endif(USE_FSAL_HPSS)

if(USE_FSAL_PROXY)
  add_subdirectory(FSAL_PROXY)
endif(USE_FSAL_PROXY)

if(USE_FSAL_CEPH)
  add_subdirectory(FSAL_CEPH)
endif(USE_FSAL_CEPH)

if(USE_FSAL_RGW)
  add_subdirectory(FSAL_RGW)
endif(USE_FSAL_RGW)

if(USE_FSAL_LUSTRE)
  add_subdirectory(FSAL_LUSTRE)
endif(USE_FSAL_LUSTRE)

if(USE_FSAL_GPFS)
  add_subdirectory(FSAL_GPFS)
endif(USE_FSAL_GPFS)

if(USE_FSAL_PT)
  add_subdirectory(FSAL_PT)
endif(USE_FSAL_PT)

if(USE_FSAL_ZFS)
  add_subdirectory(FSAL_ZFS)
endif(USE_FSAL_ZFS)

if(USE_FSAL_VFS)
  add_subdirectory(FSAL_VFS)
endif(USE_FSAL_VFS)

if(USE_FSAL_GLUSTER)
  add_subdirectory(FSAL_GLUSTER)
endif(USE_FSAL_GLUSTER)

=== src/MainNFSD/CMakeLists.txt ===
add_definitions(
  -D__USE_GNU
  -D_GNU_SOURCE
)

if(USE_DBUS)
  include_directories(
    ${DBUS_INCLUDE_DIRS}
    )
endif(USE_DBUS)

########### next target ###############

SET(MainServices_STAT_SRCS
   nfs_admin_thread.c
   nfs_rpc_callback.c
   nfs_worker_thread.c
   nfs_rpc_dispatcher_thread.c
   nfs_rpc_tcp_socket_manager_thread.c
   nfs_init.c
   nfs_reaper_thread.c
   ../support/client_mgr.c
)

if(USE_9P)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    9p_dispatcher.c)
endif(USE_9P)

if(USE_9P AND USE_9P_RDMA)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    9p_rdma_dispatcher.c
    9p_rdma_callbacks.c)
endif(USE_9P AND USE_9P_RDMA)

if(USE_NFS_RDMA)
  add_definitions(-D_USE_NFS_RDMA)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    nfs_rpc_rdma.c)
endif(USE_NFS_RDMA)

if(USE_CB_SIMULATOR)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    nfs_rpc_callback_simulator.c)
endif(USE_CB_SIMULATOR)

if(USE_UPCALL_SIMULATOR)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    fsal_upcall_simulator_thread.c
    )
endif(USE_UPCALL_SIMULATOR)

if(USE_CB_SIMULATOR)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    nfs_rpc_callback_simulator.c
    )
endif(USE_CB_SIMULATOR)

add_library(MainServices STATIC ${MainServices_STAT_SRCS})

# FSAL core sources
# fsal_manager and fsal_destroyer are the only objects referenced by the
# core server all the rest are for the common support of fsal plugins.
# we put them here in the core rather than in a lib so that they are always
# present and available for runtime linkage.

set(fsal_CORE_SRCS
   ../FSAL/fsal_convert.c
   ../FSAL/commonlib.c
   ../FSAL/fsal_manager.c
   ../FSAL/access_check.c
   ../FSAL/fsal_config.c
   ../FSAL/default_methods.c
   ../FSAL/common_pnfs.c
   ../FSAL/fsal_destroyer.c
   ../FSAL_UP/fsal_up_top.c
   ../FSAL_UP/fsal_up_async.c
   ../FSAL_UP/fsal_up_utils.c
)

########### next target ###############

SET(ganesha.nfsd_SRCS
   nfs_main.c
)

add_executable(ganesha.nfsd
  ${ganesha.nfsd_SRCS}
  ${fsal_CORE_SRCS}
)

target_link_libraries(ganesha.nfsd
  MainServices
  ${PROTOCOLS}
  ${GANESHA_CORE}
  config_parsing
  ${LIBTIRPC_LIBRARIES}
  ${SYSTEM_LIBRARIES}
)

install(TARGETS ganesha.nfsd COMPONENT daemon DESTINATION bin)


########### install files ###############

# We are still missing the install of docs and stuff

=== src/Protocols/CMakeLists.txt ===
add_subdirectory(NFS)
add_subdirectory(XDR)
add_subdirectory(NLM)
add_subdirectory(RQUOTA)

if(USE_9P)
  add_subdirectory(9P)
endif(USE_9P)


########### install files ###############

=== src/SAL/CMakeLists.txt ===
########### next target ###############

SET(sal_STAT_SRCS
   state_async.c
   state_lock.c
   state_share.c
   state_misc.c
   state_layout.c
   state_deleg.c
   nfs4_clientid.c
   nfs4_state.c
   nfs4_state_id.c
   nfs4_lease.c
   nfs4_recovery.c
   nfs41_session_id.c
   nfs4_owner.c
   nlm_owner.c
   nlm_state.c
)

if(USE_9P)
  set(sal_STAT_SRCS
    ${sal_STAT_SRCS}
    9p_owner.c
    )
endif(USE_9P)

add_library(sal STATIC ${sal_STAT_SRCS})


########### install files ###############

=== src/cache_inode/CMakeLists.txt ===
add_definitions(
  -D__USE_GNU
  -D_GNU_SOURCE
)

########### next target ###############

SET(cache_inode_STAT_SRCS
   cache_inode_access.c
   cache_inode_getattr.c
   cache_inode_remove.c
   cache_inode_link.c
   cache_inode_readdir.c
   cache_inode_rename.c
   cache_inode_lookup.c
   cache_inode_lookupp.c
   cache_inode_readlink.c
   cache_inode_rdwr.c
   cache_inode_commit.c
   cache_inode_get.c
   cache_inode_setattr.c
   cache_inode_invalidate.c
   cache_inode_misc.c
   cache_inode_create.c
   cache_inode_statfs.c
   cache_inode_init.c
   cache_inode_read_conf.c
   cache_inode_open_close.c
   cache_inode_hash.c
   cache_inode_kill_entry.c
   cache_inode_avl.c
   cache_inode_lru.c
)

add_library(cache_inode STATIC ${cache_inode_STAT_SRCS})

########### install files ###############

=== src/support/CMakeLists.txt ===
if(USE_DBUS)
  include_directories(
    ${DBUS_INCLUDE_DIRS}
    )
endif(USE_DBUS)

# string utilities.  This should eventually go into src/os
# because BSD has them and Linux doesn't

set(string_utils_STAT_SRCS
   strlcpy.c
   strnlen.c
)

add_library(string_utils STATIC ${string_utils_STAT_SRCS})

# hash function libraries

set(hash_SRCS
   murmur3.c
   city.c
)

add_library(hash STATIC ${hash_SRCS})

# uid2grp mapper
set( uid2grp_SRCS
     uid2grp.c
     uid2grp_cache.c
)

add_library( uid2grp STATIC ${uid2grp_SRCS} )

########### next target ###############

SET(support_STAT_SRCS
   nfs4_acls.c
   nfs_creds.c
   nfs_filehandle_mgmt.c
   nfs_read_conf.c
   nfs_convert.c
   nfs_ip_name.c
   ds.c
   exports.c
   fridgethr.c
   delayed_exec.c
   misc.c
   bsd-base64.c
   server_stats.c
   export_mgr.c
)

if(ERROR_INJECTION)
  set(support_STAT_SRCS
    ${support_STAT_SRCS}
    err_inject.c
    )
endif(ERROR_INJECTION)

if(APPLE)
  set(support_STAT_SRCS
    ${support_STAT_SRCS}
    misc.c
    )
endif(APPLE)

add_library(support STATIC ${support_STAT_SRCS})

########### install files ###############

=== src/test/CMakeLists.txt ===

########### next target ###############

SET(test_avl_SRCS
   test_avl.c
)

add_executable(test_avl EXCLUDE_FROM_ALL ${test_avl_SRCS})

target_link_libraries(test_avl ${CMAKE_THREAD_LIBS_INIT})


########### next target ###############

SET(test_mh_avl_SRCS
   test_mh_avl.c
   ../support/murmur3.c
)

add_executable(test_mh_avl EXCLUDE_FROM_ALL ${test_mh_avl_SRCS})

target_link_libraries(test_mh_avl ${CMAKE_THREAD_LIBS_INIT})

########### next target ###############

SET(test_glist_SRCS
   test_glist.c
)

add_executable(test_glist EXCLUDE_FROM_ALL ${test_glist_SRCS})

target_link_libraries(test_glist ${CMAKE_THREAD_LIBS_INIT})


########### install files ###############

=== src/tools/CMakeLists.txt ===

########### install files ###############

=== src/FSAL/FSAL_CEPH/CMakeLists.txt ===
add_definitions(
  -D_FILE_OFFSET_BITS=64
)

SET(fsalceph_LIB_SRCS
   main.c
   export.c
   handle.c
   mds.c
   ds.c
   internal.c
   internal.h
)

if(CEPH_PREFIX)
  include_directories("${CEPH_PREFIX}/include")
  link_directories(${CEPH_PREFIX}/lib)
endif(CEPH_PREFIX)

add_library(fsalceph SHARED ${fsalceph_LIB_SRCS})

target_link_libraries(fsalceph cephfs ${SYSTEM_LIBRARIES})

set_target_properties(fsalceph PROPERTIES VERSION 4.2.0 SOVERSION 4)
install(TARGETS fsalceph COMPONENT fsal DESTINATION ${FSAL_DESTINATION} )

=== src/FSAL/FSAL_HPSS/CMakeLists.txt ===
########### next target ###############

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")

# Already set the rpath after build, don't wait for make install
SET(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
SET(CMAKE_INSTALL_RPATH "${HPSS_PREFIX}/lib")

include_directories("${HPSS_PREFIX}/include")

SET(fsalhpss_LIB_SRCS
   fsal_convert.c
   fsal_internal.c
   main.c
   export.c
   handle.c
   file.c
   xattrs.c
)

add_library(fsalhpss SHARED ${fsalhpss_LIB_SRCS})

target_link_libraries(fsalhpss
  tirpc
  ${HPSS_LIBRARIES}
  ${SYSTEM_LIBRARIES}
)

set_target_properties(fsalhpss PROPERTIES VERSION 4.2.0 SOVERSION 4)

########### install files ###############

install(TARGETS fsalhpss COMPONENT fsal DESTINATION ${FSAL_DESTINATION} )

=== src/FSAL/FSAL_LUSTRE/CMakeLists.txt ===

########### next target ###############

SET(fsallustre_LIB_SRCS
   fsal_internal.c
   fsal_internal.h
   main.c
   export.c
   handle.c
   fsal_up.c
   file.c
   lustre_specific.c
   xattrs.c
   mds.c
   ds.c
)

add_library(fsallustre SHARED ${fsallustre_LIB_SRCS})

if(USE_FSAL_LUSTRE_UP)
  target_link_libraries(fsallustre lustreapi lcap ${SYSTEM_LIBRARIES})
else(USE_FSAL_LUSTRE_UP)
  target_link_libraries(fsallustre lustreapi ${SYSTEM_LIBRARIES})
endif(USE_FSAL_LUSTRE_UP)

set_target_properties(fsallustre PROPERTIES VERSION 4.2.0 SOVERSION 4)
install(TARGETS fsallustre COMPONENT fsal DESTINATION  ${FSAL_DESTINATION} )


########### next target ###############

if(USE_FSAL_SHOOK)
  SET(fsalshook_LIB_SRCS
    fsal_internal.c
    fsal_internal.h
    lustre_extended_types.h
    main.c
    export.c
    handle.c
    file.c
    xattrs.c
    fsal_up.c
    shook_specific.c
    mds.c
    ds.c
    )

  add_library(fsalshook SHARED ${fsalshook_LIB_SRCS})

  if(USE_FSAL_LUSTRE_UP)
    target_link_libraries(fsalshook lustreapi shook lcap ${SYSTEM_LIBRARIES})
  else(USE_FSAL_LUSTRE_UP)
    target_link_libraries(fsalshook lustreapi shook ${SYSTEM_LIBRARIES})
  endif(USE_FSAL_LUSTRE_UP)

  set_target_properties(fsalshook PROPERTIES VERSION 4.2.0 SOVERSION 4)
  install(TARGETS fsalshook COMPONENT fsal DESTINATION  ${FSAL_DESTINATION} )
endif(USE_FSAL_SHOOK)

########### install files ###############

=== src/debian/changelog ===
nfs-ganesha (2.2.0-1) stable; urgency=log

  * Ganesha supports granting delegations
  * There have been numerous config changes
  * Ganesha now includes systemd scripts
  * Improved packaging for RPM and Debian
  * Major stability improvements
  * non-QT based python tools
  * Support for Ganesha to be a pNFS DS only, no MDS
  * SECINFO in preferred order
  * LTTng support
  * NFS v4.2 support
  * Major improvements in 9p support
  * Code cleanup (checkpatch and Coverity)
  * ntirpc improvements
  * FSAL_GLUSTER updated with pNFS and ACL support and more

 -- Philippe Deniel <philippe.deniel@>  Wed, 22 Apr 2015 15:30:00 +0200

nfs-ganesha (2.1.0-1) stable; urgency=log

  * Updates for the debian packaging using the cmake build system

 -- Charles Hardin <ckhardin@gmail.com>  Fri, 29 Aug 2014 20:18:45 +0000

nfs-ganesha (1.5.0-1) stable; urgency=low
  * TIRPC library was significantly refurbished with bi-directional RPC support (required for NFSv4.1 backchannels)
  * Multiple RPC dispatch is now supported
  * Cache inode has been reworked on its handling of directory entries
  * Cache inode readdir logic is now based on callbacks to take advantage of AVL tree work
  * State Management has been unified and improved. Locking is consistent across both NFSv3 and NFSv4.x
  * Client id management support has been added	
  * 9p.2000L support has been added. Dev is currently under alpha version
  * Improved file handle support. Handles's versions and variable length handles are better supported.
  * Memory allocation has been refactored. TC-Malloc or Jemalloc can be use with a fallback to libC's malloc/free
  * Improved Kerberos support. Compatibility with Microsoft AD Kerberos is improved.
  * FSAL_SNMP is now officially deprecated

 -- Philippe Deniel <philippe.deniel@cea.fr>  Mon, 16 Jul 2012 11:11:00 +0200

nfs-ganesha (1.4.0-1) stable; urgency=low
  * Bug Fix: Memory leak fixed in RPC's DRC
  * Bug Fix: Bad computation of rbt_value in RPC's DRC's hashtable 
  * New FSAL_CEPH (dedicated to the ceph filesystem)
  * pNFS code refurbished with CEPH specific code and layout file support
  * All RPCs are now based on TIRPC	
  * Bug Fix: in nfs_Write, for clean handle of umask, the server should allow the owner of a file to write to it, even if the file is read-only
  * Bug Fix: bad memory padding in fsal_handle_t and fsal_cookie_t

 -- Philippe Deniel <philippe.deniel@cea.fr>  Thu, 15 Mar 2012 10:41:00 +0200

nfs-ganesha (1.3.0-1) stable; urgency=low
  * Lustre FSAL: exporting several Lustre filesystem with the same server
  * A bug was found and fix in OP4_READDIRPLUS (produced missing entries)
  * Directory content cached is now managed as a tree. 
  *  Lock support for FSAL_LUSTRE
  * Lustre FSAL: regression in readdir detected and fixed
  * FSAL_LUSTRE/FSAL_XFS/FSAL_FUSELIKE/FSAL_ZFS: regression in readdir detected
  * export list now support IP ranges using the CIDR format

 -- Philippe Deniel <philippe.deniel@cea.fr>  Fri, 23 Dec 2011 10:00:00 +0200

nfs-ganesha (1.2.0-1) stable; urgency=low
  * Bug Fix:  Call cache_inode_close after deleting share state
  * Added support for ERR_FSAL_DELAY in upper layer
  * FSAL code has been reorganized a lot
  * New SAL (State Abstraction Layer) to manage locks (NFSv4/NLM) and shares
  * Symbolic Links are managed via a pool to save memory in Cache_Inode
  * Early 9P support
  * Lustre FSAL: exporting several Lustre fuilesystem with the same server

 -- Philippe Deniel <philippe.deniel@cea.fr>  Mon, 12 Dec 2011 11:11:11 +0200

nfs-ganesha (1.1.1-1) stable; urgency=low
  * Bug Fix: padded size for FSAL-less daemon were too short and not aligned on 64 bits
  * Bug Fix: Badly formed fsal_op_context_t in FSAL_ZFS (issue when using as shared object)
  * Bug Fix: bad modes/ACLs management in several FSALs (produced EPERM errors)
  * Bug Fix: badly managed access_type in nfs3_Access
  * Bug Fix:  Call cache_inode_close after deleting share state
  * Added support for ERR_FSAL_DELAY in upper layer
  * FSAL code has been reorganized a lot
  * New SAL (State Abstraction Layer) to manage locks (NFSv4/NLM) and share reservations
  * NFSv4.0 are now activated by default
  * Symbolic Links are managed via a pool to save memory in Cache_Inode
  * Early 9P support
  * Lustre FSAL: exporting several Lustre fuilesystem with the same server instance

 -- Philippe Deniel <philippe.deniel@cea.fr>  Fri, 11 Nov 2011 11:11:11 +0200

nfs-ganesha (1.0.1-1) stable; urgency=low
  * Bug Fix: Bad memset in FSAL_HPSS::HPSSFSAL_lookup. Result was a segfault at init.
  * Code reorganization : subdirectory RPCAL has been added
  * Bug fix: bad 'fd2handle' options in FSAL_XFS::FSAL_rename
  * pNFS : API for implementing pNFS specific feature has been fully refurbished.
  * FSAL_VFS: new FSAL using "open_by_handle" feature added in the kernel higher than 2.6.39.
  * NFSv4: the product is now compiled with NFSv4.1 support by default
  * Log module: now using __FUNCTION__ macro to get the function's name
  * Bug Fix: the cache_inode_commit function badly managed the Data Cache.
  * Multiple FSAL support: it is now possible to 'dlopen' several fsal shared objects.
  * Bug Fix: issue occured in 'Tbl' pass of cthon04 test for FSAL_XFS and FSAL_VFS
  * NFSv4 ACLs support
  * GPFS ACLs support (to be used with NFSv4 ACL support)

 -- Philippe Deniel <philippe.deniel@cea.fr>  Wed,  7 Apr 2011 11:23:00 +0200

nfs-ganesha (1.0.5-1) stable; urgency=low
  * Using function daemon() to start the daemon in a cleaner way
  * Using gethostbyaddr_r to avoid contention when resolving address in
    nfs_ip_name.c
  * pNFS/file support has been added for LUSTRE
  * pNFS related sources were reorganized with a design closer to what is done with FSAL/MFSL
  * "stable_how" flag management has been remade in deep, including a new FSAL_sync call to every FSAL
  * FSAL_PROXY: the FSAL is no able to deal correctly when the remote server restarts


=== src/debian/control ===
Source: nfs-ganesha
Section: net
Priority: optional
Maintainer: Philippe Deniel <philippe.deniel@cea.fr>
Standards-Version: 3.9.5
Homepage: http://nfs-ganesha.sourceforge.net
Build-Depends: debhelper (>> 9),
               quilt,
               bison,
               flex,
               cmake,
               libdbus-1-dev,
               libjemalloc-dev,
               libnfsidmap-dev,
               libwbclient-dev,
               dh-python,
               python-qt4,
               pyqt4-dev-tools,
               libkrb5-dev
Vcs-Git: https://github.com/nfs-ganesha/nfs-ganesha.git

Package: nfs-ganesha
Architecture: any
Depends: dbus,
         ${perl:Depends},
         ${misc:Depends}
Description: nfs-ganesha is a NFS server in User Space
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.

Package: nfs-ganesha-fsal
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: nfs-ganesha fsal libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.

Package: python-nfs-ganesha
Pre-Depends: ${misc:Pre-Depends}
Architecture: all
Section: python
Provides: ${python:Provides}
Depends: python-dbus,
         python-qt4,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Description: Python bindings for nfs-ganesha
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains Python bindings for nfs-ganesha admin

Package: nfs-ganesha-doc
Architecture: all
Section: doc
Description: Documentation for nfs-ganesha
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains documentation and examples for nfs-ganesha

=== src/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# Expected debian/rules file that is used by the dpkg build procedure
#
#   $ git clone <nfs-ganesha>
#   $ cd nfs-ganesha/src
#   $ dpkg-buildpackage -uc -us
#
export PREFIX=/usr
export DESTDIR=$(CURDIR)/debian/tmp

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	 dh --with python2 --with quilt $@

override_dh_auto_configure:
	 dh_auto_configure -- -DBUILD_CONFIG=debian -DFSAL_DESTINATION=lib/${DEB_HOST_MULTIARCH}/ganesha

override_dh_auto_test:

override_dh_install:
	 mkdir -p debian/tmp/etc/ganesha/
	 mkdir -p debian/tmp/etc/init.d/
	 mkdir -p debian/tmp/etc/logrotate.d/
	 mkdir -p debian/tmp/etc/dbus-1/system.d/
	 cp config_samples/vfs.conf debian/tmp/etc/ganesha/ganesha.conf; \
	 cp config_samples/logrotate_ganesha debian/tmp/etc/logrotate.d/nfs-ganesha; \
	 cp scripts/init.d/nfs-ganesha debian/tmp/etc/init.d/nfs-ganesha; \
	 cp scripts/ganeshactl/org.ganesha.nfsd.conf debian/tmp/etc/dbus-1/system.d/nfs-ganesha-dbus.conf; \
	 dh_install --sourcedir=debian/tmp
